import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:stateful_provider/controller/status_controller.dart';

class StatusWidget extends StatelessWidget {
  Future Function(DartError error) consumeError;
  final Widget process;
  bool alwaysLoading;

  StatusWidget({
    required this.consumeError,
    this.alwaysLoading = false,
    this.process = const CircularProgressIndicator(),
  });

  StatusController _status = Get.find();

  @override
  Widget build(BuildContext context) => Obx(() {
        if (_status.hasError) {
          final current = _status.currentError();
          if (current != null) {
            WidgetsBinding.instance?.addPostFrameCallback((timeStamp) async {
              _status.consumeError(current);
              await consumeError(current);
            });
          }
        }
        return _status.isProcessing || alwaysLoading ? process : SizedBox();
      });
}
