import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:stateful_provider/controller/status_controller.dart';
import 'package:stateful_provider/widget/status_widget.dart';
import 'package:uuid/uuid.dart';

void main() {
  Get.put(StatusController());

  runApp(
    GetMaterialApp(
      theme: ThemeData.dark(),
      home: Scaffold(
        appBar: AppBar(
          title: Text("Stateful provider"),
        ),
        body: Stack(
          children: [
            Action(),
            Builder(
              builder: (context) => StatusWidget(
                consumeError: (error) {
                  return Scaffold.of(context)
                      .showSnackBar(SnackBar(
                        content: Text("$error"),
                        duration: Duration(seconds: 1),
                      ))
                      .closed;
                },
                process: LinearProgressIndicator(),
              ),
            )
          ],
        ),
      ),
    ),
  );
}

StatusController get status => Get.find();

final uuid = Uuid();
int count = 0;

Widget Action() {
  return Center(
    child: Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        RaisedButton(
          child: Text("Add process"),
          onPressed: () => status.add(uuid),
        ),
        RaisedButton(
          child: Text("Remove process"),
          onPressed: () => status.complete(uuid),
        ),
        RaisedButton(
          child: Text("Add error"),
          onPressed: () => status.catchError(Exception(["Error# ${count++}"])),
        ),
      ],
    ),
  );
}
